package WebFlow.QS;

import WebFlow.event.*;
import WebFlow.*;

import java.util.*;
import java.io.*;
import java.net.*;

import org.omg.CORBA.*;

public class SaveAsImp extends WebFlow.BeanContextChildSupport
    implements SaveAsOperations, WebFlowModule {

String msg_;
org.omg.CORBA.Object peer;
PropertyChangeSupport pcs;
VetoableChangeSupport vcs;
WFFileDescriptor inFile;
String source,dest;
String destFile, destDir;

public SaveAsImp(org.omg.CORBA.Object peer, String msg)
   throws WebFlow.NullPointerException
  {
    super(peer);	
    msg_ = msg;
    pcs = new PropertyChangeSupport(peer,this);
    vcs = new VetoableChangeSupport(peer,this);
    this.peer = peer;
    dest = "null";
    System.out.println("SaveAs initialized");
  }

  public void setFileName(String fullpath){
     dest = fullpath;
     System.out.println("SaveAs dest="+dest);
     int idx=dest.lastIndexOf("/");
     if(idx<0) idx=dest.lastIndexOf("\\");
     if(idx>-1) {
         destFile=dest.substring(idx+1);
         destDir=dest.substring(0,idx);
     }
     else {
        System.out.println("cannot determine directory from "+dest);
     }
  }

    public void run() {
	/* copy source to destination */
      File sFile, dFile , dDir;
      FileInputStream fr=null;
      FileOutputStream fw=null;
      boolean failure;
      int bytes_read;
      sFile=null;
      dFile=null;
      dDir=null;
 
      System.out.println("SaveAs - directory "+destDir);
      System.out.println("SaveAs - file "+destFile);
      failure=false;
      try {  
           sFile = new File(source);
           if(sFile.exists()) {
	      if(sFile.canRead()) {
                 fr = new FileInputStream(sFile);
	      }
              else {
                 failure=true;  
                 System.out.println("cannot read "+source);
	      }
	   }
           else {
                 failure=true;  
                 System.out.println(source+ "does not exists!");
	   }
           if(dest.equals("null")) {
             if((new File("/tmp")).exists()) dest="/tmp/wf.txt";
             else if((new File("C:\\tmp")).exists()) dest="C:\\tmp\\wf.txt";
             else if((new File("C:\\temp")).exists()) dest="C:\\temp\\wf.txt";
	   }
           dDir = new File(destDir);
           if(dDir.exists()) {
	      if(dDir.canWrite()) {
             System.out.println("save as: "+destDir+File.separator+destFile);
                 dFile = new File(destDir+File.separator+destFile);
                 fw = new FileOutputStream(dFile);
	      }
              else {  
                 failure=true;  
                 System.out.println("cannot write "+destDir);
	      }
	   }
           else {
                 failure=true;  
                 System.out.println(destDir+ "does not exists!");
	   }

           if(!failure) {
             byte[] buffer = new byte[4096];
             while((bytes_read = fr.read(buffer)) !=-1) {
               fw.write(buffer,0,bytes_read);
	     }
	   }
      } catch (Exception e){ System.out.println("SaveAs: io exception "+e);};
    }  

    public void Method1() {
	// input port 1
    }
    public void Method1(WFFileDescriptor fd) {
      inFile = WFFileDescriptorHelper.narrow(fd);
      source = inFile.getFileDirectory()+inFile.getFileName();
      System.out.println("SaveAs input received: "+source);
      run();
    }

    public void Method2() {
      System.out.println("SaveAsImp: input port 2 not supported");
    }    

    public void Method3() {
      System.out.println("SaveAsImp: input port 3 not supported");
    }    

  public String[] refreshDirectory(String dirName)
  {
    System.out.println("refreshDirectory is CALLED with:"+dirName+"**");
    String[] directory_contents=null;
    String dir = dirName;
    try{
      directory_contents = list(dir,"");
    }catch(InterruptedException e){
      System.out.println("InterruptedException in list of directory content:"+e);
    }
    return  directory_contents;
  }
public   String [] list(String dir,String opts)
         throws InterruptedException
  {
    String[] FileList,returnValue;
    Vector lines = new Vector();
    lines.addElement(dir);

    File file = new File(dir);

    if(file.exists()) {
	if(file.isDirectory()) {
	    if(file.canRead()) {
                 FileList = file.list();
                 lines.addElement("total xx");
                 for(int ifile=0;ifile<FileList.length;ifile++) {
                     if((new File(dir,FileList[ifile])).isDirectory()) {
                         lines.addElement("<DIR> "+FileList[ifile]);
		     }
                     else {
                         lines.addElement(FileList[ifile]);
		     }
		 }
	    }
	    else {
               System.out.println(dir+" is not readable");
               lines.addElement("total xx");
               lines.addElement(dir+"is not readable");
	    }
	}
	else {
           System.out.println(dir+" is not a directory");
           lines.addElement("total xx");
           lines.addElement(dir+"is not a directory");
	}
    } 
    else {
      System.out.println("directory "+dir+" does not exists");
      lines.addElement("total xx");
      lines.addElement(dir+"does not exists");
    }

    returnValue = new String[lines.size()];
    lines.copyInto(returnValue);
    return returnValue;

    /*
    //insert first requested directory name
    lines.addElement(dir);

    String separator = File.separator;
    boolean isExist=false,isRead=false,isDir;
    Vector lines = new Vector();
    //check that this directory exists first

    try{
      if (file.exists())
	isExist = true;
      isRead = file.canRead();

    }catch(SecurityException e){
      System.out.println("Security Exception "+e);
    }
    
    if (!isRead){
      System.out.println(dir+" is not readable");
      lines.addElement("total xx");  
      lines.addElement("NotReadable");
    }
    else if (!isExist){
      System.out.println(dir+" Not Found");
      lines.addElement("total xx");
      lines.addElement("NotFound");
    }

    if ((!isRead)||(!isExist)){
      System.out.println("file "+dir+" not found or not readable");
      String[] retval = new String[lines.size()];
      lines.copyInto(retval);
      return retval;
    }

    try{
      String line;
      String  cmd=null,pwd=null;
      Process child;
      DataInputStream in;

      //start up the command
	if (separator.equals("/")) //UNIX
        cmd = "ls -al "+dir;
      else if (separator.equals("\\")) //WIN/NT
	  cmd = "cmd.exe /C "+" DIR "+dir;   //running dir on top of WIN/NT
        //cmd = "command.com /C "+" DIR "+dir; //running dir on top of DOS
      child = Runtime.getRuntime().exec(cmd);
	System.out.println("Before DIS ");
      in = new DataInputStream(child.getInputStream());
     
      //read the command's output
      while((line = in.readLine()) != null){
 	    lines.addElement(line);
          System.out.println("line: "+line);
      }
	//User gave wrong directory name
	if (lines.size() == 0){
         System.out.println(dir+" Not Found");
         lines.addElement("total xx");
         lines.addElement("Filename ,directory name or volume label syntax is incorrect");
         String[] retval = new String[lines.size()];
         lines.copyInto(retval);
         return retval; 
	}

	// If you want to see detail , give this command "cmd /C dir " or "command /C dir"
      //Delete first three lines of output from dir command
      //Volume in drive ..; volume serial; blank line and fifth line  which is blank
	//and last three lines
      if (separator.equals("\\")){    //WIN/NT 	
	   System.out.println("Delete these (first): "+lines.elementAt(1)+"-*- "+
	                                       lines.elementAt(2)+"-*- "+
 						         lines.elementAt(3)+"-*-"+
	  						   lines.elementAt(5)+"-*-");	
	   lines.removeElementAt(1);
         lines.removeElementAt(1);
	   lines.removeElementAt(1);
         lines.removeElementAt(2);
	   int l = lines.size()-1;
	   System.out.println("Delete these (last): "+lines.elementAt(l)+"-*- "+
	                                       lines.elementAt(l-1)+"-*-");
 						         
         lines.removeElementAt(l);
         lines.removeElementAt(l-1);
	}

      String[] retval = new String[lines.size()];
      lines.copyInto(retval);
      return retval;
    } catch (Exception e){
      throw new InterruptedException (e.toString());
    }
  */
  }

  public void stop() {System.out.println("SaveAsImp: Stop called");}
}

